/*
	CsoundSampleSizeCmd.cc

	Will Eighteen, 2000: will@opaline.demon.co.uk
*/

#include "CsoundSampleSizeCmd.h"
#include "Application.h"
#include <LineEdit.h>

#include "OpResources.h"	// this is the only resources file with global resources

CsoundSampleSizeCmd::CsoundSampleSizeCmd ( const char *name, int active ) :  Cmd ( name, active )
{
	_popupRealised = False;
}


void CsoundSampleSizeCmd::doCommand()
{
	if ( _popupRealised == True )
		return;

	char buf[30];
	char help[100];
	
	_edit = new LineEdit ( ( char * ) name(), TRUE,
									&CsoundSampleSizeCmd::enterCallback,
									&CsoundSampleSizeCmd::cancelCallback,
									( void * ) this );	
                
	/* retrieve resource to be displayed */
 	snprintf ( buf, sizeof ( buf ),"%u", mixwaveResources->csoundSampleSize() );
	buf [ sizeof ( buf ) - 1 ] = 0;
	_edit->setColumns ( strlen ( buf ) );	// set width before instantiation
	snprintf ( help, sizeof ( help ), "Specifies number of wave samples per \
control-rate period: minimum 2." );
	help [ sizeof ( help ) - 1 ] = 0;
	_edit->setHelp ( help );
	_edit->execute();
	_edit->setText ( buf );	// can't set text before instantiation...
	_popupRealised = True;
}


void CsoundSampleSizeCmd::undoCommand()
{
	// not implemented
}


void CsoundSampleSizeCmd::enterCallback ( void *clientData, char *text )
{
	unsigned int num;
	CsoundSampleSizeCmd *obj = ( CsoundSampleSizeCmd * ) clientData;

	sscanf ( text, "%u", &num );

	if ( num > 1 )	// spatialisation uses linear interpolation, so at least 2
		obj->enter ( num );	

	obj->_popupRealised = False;
	delete obj->_edit;
}


/* specify resource to be set on 'enter' or 'ok' */
void CsoundSampleSizeCmd::enter ( unsigned int num )
{
	mixwaveResources->csoundSampleSize ( num );
}


void CsoundSampleSizeCmd::cancelCallback ( void *clientData )
{
	CsoundSampleSizeCmd *obj = ( CsoundSampleSizeCmd * ) clientData;

	delete obj->_edit;
	obj->_popupRealised = False;
}
