/*
	IntToFloatCmd.h - convert integer format file to floating point

	Will Eighteen, 2000: will@opaline.demon.co.uk
*/

#ifndef INTTOFLOATCMD_H
#define INTTOFLOATCMD_H

#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif


#define BUFSIZE 1024


class FileAccess;

class IntToFloatCmd : public BreakCmd
{
	public:
		IntToFloatCmd ( char *, int, char *, char * );
		virtual ~IntToFloatCmd();
		char *source() { return _srcFile; };
		char *target() { return _dstFile; };
		int error() { return _error; }
		void offset ( float num ) { _offset = num; }
		void scale ( float num ) { _scale = num; }

	protected:
		void doCommand();
		
	private:
		char _srcFile[BUFSIZE];
		char _dstFile[BUFSIZE];
		FileAccess *_in;
		FileAccess *_out;
		int _once, _percentDone, _iValue, _error;
		float _fValue, _offset, _scale;
};

#endif
