/*
 SeparatorInterface.cc

 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/

#include "SeparatorInterface.h"
#include <Xm/Separator.h>


SeparatorInterface::SeparatorInterface ( Widget parent, Cmd *cmd ) : CmdInterface ( cmd )
{
	_w = XtCreateWidget ( _name, xmSeparatorWidgetClass, parent, NULL, 0 );
	installDestroyHandler();
	
	if ( _active )
		activate();
	else
		deactivate();
		
	XtAddCallback ( _w, XmNactivateCallback, &CmdInterface::executeCmdCallback,
					( XtPointer ) this );
}
